<template>
  <section id="subfaq">
    <div v-if="/^Participer/.test(concern)">
      <h2
        v-html="`${$t('subfaq.participate.title')} ${
          $t(`color.${concern.split(' - ')[1]}`)}`"
      ></h2>
      <div
        v-html="$t('home.participate.dev', html)"
      ></div>

      <b-row align-h="center">
        <b-col
          v-if="$te(`src.${concern.split(' - ')[1]}`)"
          sm="6"
        >
          <a
            :href="$t(`src.${concern.split(' - ')[1]}`)"
            class="btn btn-block border mb-4"
          >
            <svg-icon
              :label="$t(`soft.${concern.split(' - ')[1]}`)"
              name="code-branch"
              size="lg"
              variant="fb-b7 disc fc-light d-block mx-auto"
            />
          </a>
        </b-col>
        <b-col
          v-if="$te(`git.${concern.split(' - ')[1]}`)"
          sm="6"
        >
          <a
            :href="$t(`git.${concern.split(' - ')[1]}`)"
            class="btn btn-block border mb-4"
          >
            <svg-icon
              :label="$t(`color.${concern.split(' - ')[1]}`)"
              name="b-git"
              size="lg"
              variant="fb-b7 disc fc-light d-block mx-auto"
            />
          </a>
        </b-col>
      </b-row>
      <div v-html="$t('home.participate.other')"></div>
      <div v-html="$t('subfaq.participate.next')"></div>
      <b-row>
        <b-col
          sm="6"
          class="mx-auto p-0"
        >
          <a
            :href="`${$t('link.colibri')}/c/qualite/23/`"
            class="btn btn-block border mt-2 mb-4"
          >
            <svg-icon
              :label="$t('subfaq.participate.forum')"
              name="comment"
              size="lg"
              :variant="`bg-${bs} disc fc-light d-block mx-auto`"
            />
          </a>
        </b-col>
      </b-row>
    </div>

    <!-- Reminders ~date/~forms -->
    <b-card
      v-if="/^(date|forms)$/.test($t(concern, '-k~l'))"
      no-body
      class="bg-light mb-4"
    >
      <b-card-body
        v-html="$t(`home.reminder.${$t(concern, '-k~l')}`)"
      />
    </b-card>

    <!-- Answers -->
    <div
      :class="`${
        /^all$/.test(state.toggle) ? 'all' : ''
      } ${
        search !== '' ? 'filter' : 'nofilter'
      }`"
    >
      <h2
        v-if="categories.includes(category)"
        v-html="`${
          getFramaname(category) === undefined
            ? $t(`faq.${category}.title`)
            : getFramaname(category)
        } - ${$t('home.faq')}`"
      ></h2>
      <h2
        v-else
        v-html="$t('subfaq.mainFaq')"
      ></h2>

      <b-input-group
        size="lg"
        class="mb-4"
      >
        <b-input-group-append>
          <b-button
            variant=" fc-g7"
            @click="search = ''"
          >
            <svg-icon
              v-show="search === ''"
              name="search"
            />
            <svg-icon
              v-show="search !== ''"
              name="backspace"
            />
          </b-button>
        </b-input-group-append>
        <b-form-input
          v-model="search"
          :aria-label="$t('txt.search')"
          :placeholder="$t('txt.search')"
          type="text"
          size="40"
          class="rounded-0"
        />
      </b-input-group>

      <b-list-group>
        <b-list-group-item
          v-for="(item, index) in faq"
          :key="index"
          :active="state.toggle === item.id"
          :variant="item.variant"
        >
          <a
            v-show="state.toggle === item.id"
            href="#!"
            class="pull-right close"
            aria-hidden="true"
            onclick="return false"
            @click="toggleAnswer(item.id)"
          >×</a>
          <a
            :id="item.id"
            :href="`${$t('link.contact')}/faq/#${item.id}`"
            class="toggle"
            onclick="return false"
            @click="toggleAnswer(item.id)"
          ></a>
          <h3
            class="list-group-item-heading"
            @click="toggleAnswer(item.id)"
            v-html="item.question"
          ></h3>
          <div
            class="list-group-item-text"
            v-html="item.answer"
          ></div>
          <p class="text-center mb-0">
            <b-button
              v-show="state.toggle === item.id"
              variant="light"
              size="sm"
              @click="toggleAnswer(item.id)"
              v-text="$t('txt.close')"
            />
          </p>
        </b-list-group-item>
      </b-list-group>
      <p
        v-if="!state.mainFaq && state.toggle === 'all'"
        class="mb-0 mt-3"
      >
        <b-button
          block
          :variant="`outline-${bs} text-center`"
          @click="addMainFaq()"
          v-html="$t('subfaq.more')"
        />
      </p>
    </div>

    <div
      v-if="!/^Participer/.test(concern)"
      v-show="state.toggle === 'all'"
      class="no-answer"
    >
      <!-- No answer ? -->
      <p v-html="$t('subfaq.noanswer')"></p>
      <div v-if="/(help|support)/.test(section)">
        <div v-if="$te(`doc.${$t(category, '-k~lL@')}`)">
          <p
            v-html="$t('subfaq.help.docs', {
              service: $t(`color.${$t(category, '-k~lL@')}`)
            })"
          ></p>
          <b-col
            sm="6"
            class="mx-auto p-0"
          >
            <a
              :href="`${$t('link.docs')}/${$t(`doc.${$t(category, '-k~lL@')}`)[0]}`"
              class="btn btn-block border mb-4"
              onclick="return false;"
              @click="$root.$children[0].modal.docs = true;
                      $root.$children[0].modal.link =
                        `${$t('link.docs')}/${$t(`doc.${$t(category, '-k~lL@')}`)[0]}`"
            >
              <svg-icon
                :label="$t('subfaq.menu.docs')"
                :name="$t('svg.docs')"
                size="lg"
                variant="fb-j7 disc fc-light d-block mx-auto"
              />
            </a>
          </b-col>
        </div>
      </div>
      <div v-html="$t('subfaq.help.next')"></div>
      <b-row>
        <b-col sm="6">
          <a
            :href="`${$t('link.contact')}/#${category}`"
            class="btn btn-block border mb-2"
            onclick="return false;"
            @click="showContact()"
          >
            <svg-icon
              :label="`${$t('subfaq.contact')} ${$t('color.soft')}`"
              name="envelope"
              size="lg"
              :variant="`bg-${bs} disc fc-light  d-block mx-auto`"
            />
          </a>
        </b-col>
        <b-col sm="6">
          <a
            :href="`${$t('link.colibri')}${section === 'help' ? '/c/entraide/53' : ''}`"
            class="btn btn-block border mb-2"
          >
            <svg-icon
              :label="$t('subfaq.forum')"
              name="comment"
              size="lg"
              :variant="`bg-${bs} disc fc-light  d-block mx-auto`"
            />
          </a>
        </b-col>
      </b-row>
    </div>
  </section>
</template>

<script>
export default {
  props: {
    concern: {
      type: String,
      required: true,
    },
    section: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      mainFaq: [],
      categoryFaq: [],
      faq: [],
      search: '',
      categories: Object.keys(this.$t('faq')).filter(i => !/title/.test(i)),
      category: '',
      service: this.concern.split(' - ')[2],
      state: {
        mainFaq: false,
        toggle: 'all',
        status: false,
      },
      id: '',
      status: [],
      bs: 'primary',
      html: {
        git: ` <i class="fa fa-lg fa-git" aria-hidden="true"></i>
          <span class="sr-only">git</span>`,
        source: ` <i class="fa fa-lg fa-code-fork" aria-hidden="true"></i>
          <span class="sr-only">source</span>`,
        link: `${this.$t('baseurl')}#issue-git`,
      },
    };
  },

  watch: {
    concern(newValue) {
      if (newValue) {
        this.id = '0';
        switch (this.concern.split(' - ')[0]) {
          case 'Soutenir':
            this.category = 'les_dons';
            this.bs = 'soutenir';
            break;
          case 'Invitation à un événement':
            this.category = 'autres';
            this.bs = 'danger';
            break;
          case 'Partenariat':
            this.category = 'partnership';
            this.bs = 'warning';
            break;
          case 'Framablog':
            this.category = 'partnership';
            this.bs = 'warning';
            break;
          case 'Framabook':
            this.category = 'partnership';
            this.bs = 'warning';
            break;
          case 'Participer':
            this.category = 'benevolat';
            this.bs = 'info';
            break;
          case '---': // general
            this.category = 'autres';
            this.bs = 'primary';
            break;
          default:
            this.category = this.$t(this.concern, '-ktlL@');
            this.id = this.$te(`status.${this.$t(this.category, '-k~')}`)
              ? this.$t(`status.${this.$t(this.category, '-k~')}`)
              : '0';
            this.bs = 'success';
            break;
        }
        this.faq = [];
        this.categoryFaq = [];
        this.$parent.$parent.$parent.activity = [new Date().getTime()];
        this.status = [];
        this.state.status = false;
        this.search = '';
        this.checkStatus();
        this.loadFaq();
      }
    },
    search(newValue) {
      if (newValue) {
        this.searchUpdate();
      }
    },
    status(newValue) {
      if (newValue) {
        this.faq = this.categoryFaq;

        if (this.faq.length === 0) {
          this.faq = this.mainFaq;
          this.state.mainFaq = true;
        }

        if (this.status.length > 0) {
          this.faq = this.status.concat(this.faq);
        }
      }
    },
  },
  methods: {
    getFramaname(key) {
      return this.$te(`color.${this.$t(key, '-k~lL@')}`)
        ? this.$t(`color.${this.$t(key, '-k~lL@')}`)
        : undefined;
    },

    loadFaq() {
      let q = Object.keys(this.$t('faq.autre')).filter(i => !/title/.test(i));
      for (let i = 0; i < q.length; i += 1) {
        this.mainFaq[i] = {
          id: q[i],
          question: this.$t(`faq.autre.${q[i]}.q`),
          answer: this.$t(`faq.autre.${q[i]}.a`)
            .replace(/<a href="https:\/\/contact.framasoft.org([\S\s]*?)">([\S\s]*?)<\/a>/g, '$2'),
          variant: '',
        };
      }

      /* Site Faq */
      if (this.categories.includes(this.category)) {
        q = Object.keys(this.$t(`faq.${this.category}`)).filter(i => !/title/.test(i));
        for (let i = 0; i < q.length; i += 1) {
          this.categoryFaq[i] = {
            id: q[i],
            question: this.$t(`faq.${this.category}.${q[i]}.q`),
            answer: this.$t(`faq.${this.category}.${q[i]}.a`)
              .replace(/<a href="https:\/\/contact.framasoft.org([\S\s]*?)">([\S\s]*?)<\/a>/g, '$2'),
            variant: '',
          };
        }
      }
      this.faq = this.categoryFaq;

      if (this.faq.length === 0) {
        this.faq = this.mainFaq;
        this.state.mainFaq = true;
      }

      if (this.status.length > 0) {
        this.faq = this.status.concat(this.faq);
      }
    },

    toggleAnswer(id) {
      if (this.state.toggle === 'all') {
        this.$parent.$parent.$parent.activity.push(id);
      }
      this.state.toggle = this.state.toggle === 'all' ? id : 'all';
      window.setTimeout(() => { this.$scrollTo(`#${id}`); }, 100);
    },

    showContact() {
      this.$parent.$parent.$parent.state = {
        section: this.section,
        concern: this.concern,
        active: 4,
        disabled: /(support|general)/.test(this.section) ? [2] : [],
      };
      this.$scrollTo('#sections');
    },

    addMainFaq() {
      this.faq = this.faq.concat(this.mainFaq);
      this.state.mainFaq = true;
    },

    searchUpdate() {
      const words = this.$t(this.search.replace(/\+ ?/, '_'), '-kLl@').split('_');
      const reg = new RegExp(`(${words.join('|')})`, 'g');

      if (!this.state.mainFaq) { /* search = more results */
        this.addMainFaq();
      }
      this.state.toggle = 'all';

      for (let i = 1; i < this.faq.length; i += 1) {
        const content = this.$t(`${this.faq[i].question} ${this.faq[i].answer}`, '-kLl@');
        if (reg.test(content)) {
          this.faq[i].variant = `${this.faq[i].variant.replace(/search/g, '')} search`;
        } else {
          this.faq[i].variant = this.faq[i].variant.replace(/search/g, '');
        }
      }
    },

    checkStatus() {
      /* Status */
      if (this.id !== '0' && !this.state.status) {
        fetch(`https://status.framasoft.org/api/v1/components?id=${this.id}`)
          .then(res => res.json())
          .then((data) => {
            if (data.data[0].status > 1) { // There is a incident
              const variant = data.data[0].status < 4 ? 'warning' : 'danger';
              this.loadLastIncident(this.id, variant);
            }
            this.state.status = true;
          })
          .catch((err) => { console.error(err); }); // eslint-disable-line
      }
      this.loadScheduledIncidents();
    },

    loadLastIncident(id, variant) {
      fetch(`https://status.framasoft.org/api/v1/incidents?component_id=${id}&sort=id&order=desc`)
        .then(res => res.json())
        .then((data) => {
          if (data.data.length > 0) {
            this.status.unshift({
              id: 'incident_0',
              question: data.data[0].name,
              answer: `<p>${data.data[0].message.replace('\r\n', '<br>')}</p>`,
              variant,
            });
          }
        })
        .catch((err) => { console.error(err); }); // eslint-disable-line
    },

    loadScheduledIncidents() {
      fetch('https://status.framasoft.org/api/v1/incidents?component_id=0&sort=id&order=desc')
        .then(res => res.json())
        .then((data) => {
          for (let i = 0; i < data.data.length; i += 1) {
            const day = data.data[i].scheduled_at.replace(/-/g, '/').substr(0, 10);
            const nextDay = new Date(new Date(day).getTime() + (2 * 24 * 60 * 60 * 1000))
              .toISOString()
              .split('T')[0]
              .replace(/-/g, '/');
            if (this.is.before(nextDay) && this.getFramaname(this.category) !== undefined) {
              const reg = new RegExp(`(${this.$t(this.getFramaname(this.category), '-tLl')})`, 'g');
              const content = this.$t(`${data.data[i].message} ${data.data[i].name}`, '-kLl');
              if (reg.test(content)) {
                this.status.unshift({
                  id: `maintenance_${i + 1}`,
                  question: data.data[i].name,
                  answer: `<p>${data.data[i].message.replace('\r\n', '<br>')}</p>`,
                  variant: 'info',
                });
              }
            }
          }
        })
        .catch((err) => { console.error(err); }); // eslint-disable-line
    },
  },
};
</script>
